;------------------------------------------
;testni program za SMD tiskanino z 
;4 displeji multiplex
;URA s PCF8593
;termometer z DS1820
;SCL=RA2
;SDA=RA3
;razpored:
;portb b7-b0:"fged.cba"
;porta:	1000=RA0
;	100=RA1
;	10=RA7
;	1=RA6
;Avtor Straser Silvo
;www2.maxi.si	 
;------------------------------------------ 

	list P=16F628
	
#include "d:\asm\p16f628.inc"

	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON & _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT
	
;definiranje rabe pinov
#DEFINE KAT1 PORTA,6
#DEFINE KAT2 PORTA,7
#DEFINE KAT3 PORTA,1
#DEFINE KAT4 PORTA,0
#DEFINE SCL PORTA,2
#DEFINE SDA PORTA,3
#DEFINE I2C_PIN b'11110011'	;uporabla i2C rutina
#define PIN1W PORTA,3		;uporabljen pin za 1Wire 
#DEFINE ALARM PORTA,2		;izhod za rele

#define U_GOR TIPKE,1		;tipka za dolocitev mesta nastavljanja 
#define U_DOL TIPKE,2		;tipka za nastavljane cifre na mestu
#define TIPKA_S TIPKE,3		;tipka set
#define VHOD_IMP TIPKE,1	;vhod impulza
#define TIPKA_RES TIPKE,2	;tipka reset


;definiranje bitov regista ki ga uporabljam za kontrolo
#define PIKA	KONTROLNI,0	;ob postavljenem bitu se prizge pika pri uri
#define SET_HITRO KONTROLNI,1	;postavljen bit hitro nastavljanje
#define MERITEV KONTROLNI,3	;ko je bit postavljen se v proceduri ki osvezi displej izvede meritev na 1wire
#define PREDZNAK KONTROLNI,4	;postavljen bit negativni prikaz
#define TERMO_ON KONTROLNI,5	;bit se rabi v proceduri osvezi - definira mesto dec.pike
#define DS_ERR KONTROLNI,6	;postavljen ob neuspesni inicializaciji DS1820
#define ACK KONTROLNI,7		;potrditev

#define POCASI .40		;pocasno premikanje POCASI*4ms
#define HITRO .5		;hitro premikanje  HITRO*4ms
#define CAS_TIPKE .10		;koliko stevilk se obrne, da se zacne hitra nastavitev


	cblock 0X20
	KONTROLNI,TMP,WTMP,STMP,TIPKE,CIFRA:4,CAS:2,CAS1:2,TSEC,SEKUNDA
	T1,T2,TIME_SET
	I2C_TMP,I2C_DATA,I2C_COUNT
	SEKUNDE,MINUTE,URE,T_TIPKA
	P1W,PODATEK_DS,STEVEC_DS,NIZEK_DS,VISOK_DS,DS_STOPNJA
	endc
	
	constant URA2 = CAS
	constant URA1 = MINUTE
	
	org 0x0
	goto GLAVNI
	org 0x04
	goto PREKINITEV
	
	org 0x05
;-----------------------------------------------
;tabela vraca vrednosti za prikaz na displej
;-----------------------------------------------
TABELA
	addwf PCL,f
	       ;fgedPcba'
	retlw b'10110111'	;0
	retlw b'00000110'	;1
	retlw b'01110011'	;2
	retlw b'01010111'	;3
	retlw b'11000110'	;4
	retlw b'11010101'	;5
	retlw b'11110101'	;6
	retlw b'00000111'	;7
	retlw b'11110111'	;8
	retlw b'11010111'	;9
	retlw b'00000000'	;
	retlw b'01000000'	;
	retlw b'00000010'	;
	retlw b'00000100'	;
	retlw b'00001000'	;
	retlw b'00010000'	;
	retlw b'00100000'	;
	retlw b'01000000'	;
	retlw b'10000000'	;
	retlw b'00000001'	;
	retlw b'00000001'	;
	retlw b'00000001'	;
	
	
;-----------------------------------------------
;prekinitvena rutina
;-----------------------------------------------
PREKINITEV
	movwf WTMP	
	swapf STATUS,W
	movwf STMP
	clrf STATUS
	btfsc INTCON,T0IF
	goto TMR_IRQ
KONEC_P
	swapf STMP,w
	movwf STATUS
	swapf WTMP,f
	swapf WTMP,w
	retfie
	
TMR_IRQ
	btfsc TERMO_ON
	goto TERMOMETER
	btfss U_GOR		;je tipka za gor spusena?
	goto NA_TIPKO1		;ne
	btfss U_DOL		;je tipka za dol spuscena?
	goto NA_TIPKO1
	bcf SET_HITRO
	movlw POCASI
	movwf TIME_SET
	movlw CAS_TIPKE
	movwf T_TIPKA
	
NA_TIPKO1	
	btfsc U_GOR
	goto NA_TIPKO2 
	movlw URA1
	call URA_GOR
	movlw URA1
	call SHRANI_CAS
NA_TIPKO2
	btfsc U_DOL
	goto NA_PRIKAZ 
	movlw URA1
	call URA_DOL
	movlw URA1
	call SHRANI_CAS
NA_PRIKAZ	
	call URA
TERMOMETER
	call OSVEZI
	bcf INTCON,T0IF	
	goto KONEC_P

	
;--------------------------------------
;	
;--------------------------------------
URA
	call CITAJ_CAS
	movf MINUTE,w
	andlw b'1111'
	movwf CIFRA
	swapf MINUTE,W
	andlw b'1111'
	movwf CIFRA+1
	movf URE,w
	andlw b'1111'
	movwf CIFRA+2
	swapf URE,W
	andlw b'1111'
	movwf CIFRA+3
	movf CIFRA+3,w		;
	movlw .10		
	btfsc STATUS,Z		;je na mestu desetice ure "0"		
	movwf CIFRA+3		;da zato 0 ne kazem
	return
		
;-----------------------------------------------
;procedura ob klicu osvezi displej 
;ob vsakem klicu se osvezi naslednji 
;displej
;-----------------------------------------------
OSVEZI
	btfss TERMO_ON
	goto CIF2
	btfss MERITEV
	goto CIF2
	bcf KAT4
	call TEST_DS
	bcf MERITEV
	return
CIF2	
	btfss KAT1	;se je zadnja osvezila enica?
	goto CIF3	;ne
	bcf KAT1	;da jo izkljucim
	call BERI_TIPKE	;procedura prebere pritisnjene tipke
	movf CIFRA+1,w	;pripravim vrednost za naslednji prikaz
	call TABELA	;tabela vrne vrednost za prikaz
	btfsc TERMO_ON	;prikaz za termometer
	iorlw b'1000'	;da decimalna pika
	movwf PORTB	;
	bsf KAT2
	return
CIF3
	btfss KAT2	;se je zadnja osvezevala desetica?
	goto CIF4	;ne
	bcf KAT2	;da jo izkljucim
;	call BERI_TIPKE
	movf CIFRA+2,w	;pripravim vrednost za naslednji prikaz
	call TABELA	;tabela vrne vrednost za prikaz
	btfsc TERMO_ON	;je prikaz za termometer
	goto $+3
	btfsc SEKUNDE,0
	iorlw b'1000'
	movwf PORTB	;
	bsf KAT3
	return
CIF4
	btfss KAT3	;se je zadnja osvezevala stotica?
	goto CIF1	;ne
	bcf KAT3	;da jo izkljucim
	movf CIFRA+3,w	;pripravim vrednost za naslednji prikaz
	call TABELA	;tabela vrne vrednost za prikaz
	movwf PORTB	;
	bsf KAT4
	bsf MERITEV
	return	
CIF1
	bcf KAT4	;
	movf CIFRA,w	;pripravim vrednost za naslednji prikaz
	call TABELA	;tabela vrne vrednost za prikaz
	movwf PORTB	;
	bsf KAT1
	return
	
;-----------------------------------------------
;procedura ob klicu vrne v register
; TIPKE stranje tipk
;-----------------------------------------------
BERI_TIPKE
	bcf PORTB,0	;skupni konec tipk
	bsf STATUS,RP0	;bank1
	movlw b'11111110'
	movwf TRISB	;pini 1-7 so vhodi
	nop
	nop
	nop
	nop
	nop
	bcf STATUS,RP0	;bank0
	movf PORTB,w
	movwf TIPKE
	bsf STATUS,RP0	
	clrf TRISB
	bcf STATUS,RP0
	return
	
;-----------------------------------------------
;pristevanje
;procedura ob klicu poveca vrednost za prikaz
;za 1 po urinem sistemu
;ni koncano !!!!
;----------------------------------------------
URA_GOR	
	decfsz TIME_SET,f
	return
	movwf FSR		;indirektno naslavljanje dolocim prvi register
	movlw HITRO
	btfss SET_HITRO
	movlw POCASI
	movwf TIME_SET
	btfss SET_HITRO
	call S_TIPK		
;	call CITAJ_CAS
	incf INDF,f		;povecam register minute za 1
	movf INDF,w		;rezultat preslikam v W
	andlw b'1111'		;zanimajo me le spodnji nizji biti (0-9)
	sublw .10		;W-10
	btfss STATUS,Z		;=0
	return			;ne 
	movlw b'11110000'	;
	andwf INDF,f		;ker je rezutat vecji od 9 spodnje bite brsem
	swapf INDF,f		;menjava zgornjih bitov s spodnjimi
	incf INDF,f		;povecam desetico za 1
	movlw b'1111'
	andwf INDF,w		;zgornji biti me ne zanimajo
	sublw .6		;W-6
	btfsc STATUS,Z
	goto NA_URO		;
	swapf INDF,f
	return
NA_URO
	clrf INDF		;obrisem register z minutami
	incf FSR,f
	incf INDF,f		;povecam prikaz za 1 na enici ure
	movf INDF,W		;
	andlw b'1111'
	sublw .10		;je mogoce 10
	btfss STATUS,Z		;
	goto PREVERI
	movlw b'11110000'
	andwf INDF,f
	swapf INDF,f
	incf INDF,f		;povecam prikaz na desteici ure za 1
	movf INDF,w		;
	swapf INDF,f
PREVERI
	swapf INDF,f
	movf INDF,w
	andlw b'11'
	sublw .2		;je na destici ure prikaz 2
	btfss STATUS,Z
	goto OBRNI
	swapf INDF,f
	movf INDF,w
	andlw b'1111'		;spodnji biti enica ure
	sublw .4
	btfss STATUS,Z
	return
	movlw b'11000000'
	andwf INDF,f
	return
OBRNI
	swapf INDF,f
	return
		
	
	
;-----------------------------------------------
;Procedura odsteva po urinem sistemu
;uporabljam indirektno naslavljanje
;-----------------------------------------------
URA_DOL
	movwf FSR
	decfsz TIME_SET,f
	return
	movlw HITRO
	btfss SET_HITRO
	movlw POCASI
	movwf TIME_SET
	btfss SET_HITRO
	call S_TIPK		;procedura po dolocenim stevilo klicev vkljuci hitro nastavitev
	movlw b'1111'
	andwf INDF,w		;preverjam ce je v registru enice minut 0
	btfsc STATUS,Z
	goto ODSTEJ10
	decf INDF,f
	return
ODSTEJ10
	movlw .9
	iorwf INDF,f		;v nizkem registru enic minut je bila vrednost 0
	swapf INDF,f		;rotiram register
	movlw b'1111'
	andwf INDF,w		;tukaj imam rezultat zgornjega registra minut
	btfsc STATUS,Z		;je rezultat 0
	goto ODSTEJ_URO		;da 
	decf INDF,f
	swapf INDF,f
	return
ODSTEJ_URO
	movlw .5		;v minutnem registru je bila vrednost 0 za desetico
	iorwf INDF,f		;zato v njega napisem vrednost 5
	swapf INDF,f		;ter vrnem register v prvotno stanje
	incf FSR,f		;grem na naslednji register
	movlw b'1111'
	andwf INDF,w
	btfsc STATUS,Z		;je vrednost 0
	goto ODSTEJ_URO1
	decf INDF,f
	return
ODSTEJ_URO1
	swapf INDF,w	
	andlw b'11'
	btfsc STATUS,Z
	goto URA_00
ODSTEJ_URO2
	movlw .9
	iorwf INDF,f		;v enico ure vpisem 9
	swapf INDF,f
	decf INDF,f
	swapf INDF,f
	return			
URA_00
	movlw b'100011'		;ker je prikaz 00 vpisem 23	
	iorwf INDF,f		;
	return

	
;-----------------------------------------------
;hexdec procedura pretvori 2 registra v 
;katerih so minute in ure v 4 za prikaz
;-----------------------------------------------
HEX_DEC
	movwf FSR	;najprej minute
	movf INDF,w
	movwf CIFRA	;
	clrf CIFRA+1
Z_HD
	movlw .10
	subwf CIFRA,w
	btfss STATUS,C
	goto NA_URE
	movwf CIFRA
	incf CIFRA+1,f
	goto Z_HD
NA_URE
	incf FSR,f
	movf INDF,w
	movwf CIFRA+2	;
	clrf CIFRA+3
Z_HD1
	movlw .10
	subwf CIFRA+2,w
	btfss STATUS,C
	return
	movwf CIFRA+2
	incf CIFRA+3,f
	goto Z_HD1

;-----------------------------------------------
;procedura po preteku klicev vkljuci hitro 
;nastavitev
;-----------------------------------------------
S_TIPK
	decfsz T_TIPKA,f
	return
	bsf SET_HITRO
	return
	
;-----------------------------------------------
;brsanje rama bank0
;-----------------------------------------------
CLRRAM
	movlw 0x20
	movwf FSR
BRISI
	clrf INDF
	incf FSR,f
	movlw 0x80
	subwf FSR,w
	btfss STATUS,C
	goto BRISI
	return
		
;-----------------------------------------------
;pavza
;-----------------------------------------------
PAVZA
	movlw .250
	movwf T1
	movwf T2
	decfsz T1,f
	goto $-1
	decfsz T2,f
	goto $-3
	return		
;/////////////////////////////////////////////////////////////////////////
;I2C RUTINE
;-----------------------------------------------
;procedura poslje na vodilo i2c start bit
;procedura se zakljuci z nizkim SDA ter SCL
;-----------------------------------------------
START_BIT
	movlw I2C_PIN
	andwf PORTA,f
	bsf STATUS,RP0
	bsf SCL
	bsf SDA
	nop
	nop
	nop
	nop
	nop
	bcf SDA
	nop
	nop
	nop
	nop
	nop
	bcf SCL
	bcf STATUS,RP0
	return


;-----------------------------------------------
;procedura poslje podatek na vodilo I2C
;procedura se zakljuci z nizkim SCL ter visokim
;SDA
;-----------------------------------------------
I2C_TX
	movwf I2C_DATA		;shranem podatek, ki ga bom poslal na vodilo
	movlw .8		;
	movwf I2C_COUNT	
I2C_ZANKA	
	rlf I2C_DATA,f
	btfss STATUS,C
	goto BIT0
	bsf STATUS,RP0
	bsf SDA
NA_CLK
	bsf SCL
	nop
	nop
	nop
	nop
	nop
	bcf SCL
	bcf STATUS,RP0
	decfsz I2C_COUNT,f
	goto I2C_ZANKA
	goto POTRDI
BIT0
	bsf STATUS,RP0
	bcf SDA
	goto NA_CLK
POTRDI
	bsf STATUS,RP0
	bsf SDA
	bsf SCL
	nop
	nop
	nop
	nop
	nop
	bcf SCL
	bcf STATUS,RP0
	return

;-----------------------------------------------
;procedura sprejema z i2c vodila
;pricakuje nizek SCL
;-----------------------------------------------
I2C_RX
	clrf I2C_DATA
	movlw .8
	movwf I2C_COUNT
RX_ZANKA
	bsf STATUS,RP0
	bsf SCL
	bcf STATUS,RP0
	bcf STATUS,C
	btfsc SDA
	bsf STATUS,C
	rlf I2C_DATA,f
	bsf STATUS,RP0
	bcf SCL
	bcf STATUS,RP0
	decfsz I2C_COUNT,f
	goto RX_ZANKA
	movf KONTROLNI,W
	bsf STATUS,RP0
	movwf KONTROLNI
	bsf SDA
	btfss ACK
	bcf SDA
	nop
	bsf SCL
	nop
	nop
	nop
	nop
	nop
	bcf SCL
	bsf SDA
	bcf STATUS,RP0
	return
	
;-----------------------------------------------
;procedura generira stop bit
;-----------------------------------------------
STOP_BIT
	bsf STATUS,RP0
	bcf SDA
	nop
	bsf SCL
	nop
	nop
	nop
	nop
	nop
	bsf SDA
	bcf STATUS,RP0
	return
;//////////////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////////////	
;1WIRE rutine

;-------------------------------------------------
;reset DS-ja
;-------------------------------------------------
RESET_DS
	bcf PIN1W		;pin 1wire je nizek
	bsf STATUS,RP0
	bcf PIN1W
	bcf STATUS,RP0
	movlw .49
	call PAVZA1W		;pavza ca 490uS
	bsf STATUS,RP0
	bsf PIN1W		;vhod (logicna 1)
	bcf STATUS,RP0
	movlw .8
	call PAVZA1W		;pavza ca 80uS
	bsf DS_ERR
	btfss PIN1W		;je senzor na vodilu?
	bcf DS_ERR		;da
	movlw .41
	call PAVZA1W		;minimalna dolzina slota je 480uS korekcija casa	
	return
	
;------------------------------------------------
;procedura izvede vpis vrednosti dobljene v W
; na ds
;------------------------------------------------	
VPISI_DS
	movwf PODATEK_DS	;dobljen W shranem
	movlw .8
	movwf STEVEC_DS
Z_DSV	
	bsf STATUS,RP0
	bcf PIN1W		;pin je nizek
	bcf STATUS,RP0		;
	rrf PODATEK_DS,f
	btfsc STATUS,C
	goto VISOK_BIT
	movlw .6
	call PAVZA1W
	bsf STATUS,RP0
	bsf PIN1W		;sprostim 1wire pin
	bcf STATUS,RP0
	decfsz STEVEC_DS,f
	goto Z_DSV
	return
VISOK_BIT
	bsf STATUS,RP0
	bsf PIN1W		;sprostim 1wire pin
	bcf STATUS,RP0
	movlw .6
	call PAVZA1W
	decfsz STEVEC_DS,f
	goto Z_DSV
	return
		

;-----------------------------------------------
;procedura vrne v W prebrano vrednost, ki jo
;je poslal DS
;-----------------------------------------------
BERI_DS
	clrf PODATEK_DS
	movlw .8
	movwf STEVEC_DS
Z_DSB
	bsf STATUS,RP0
	bcf PIN1W
	nop
	bsf PIN1W
	bcf STATUS,RP0
	setc	
	btfss PIN1W
	clrc
	rrf PODATEK_DS,f
	movlw .6
	call PAVZA1W	;pavza ca 30us
	decfsz STEVEC_DS,f
	goto Z_DSB
	movf PODATEK_DS,W
	return
		
;-------------------------------------------------
;pavza katero koristi rutina 1W in je odvisna 
;od prejete vrednosti v W
;pavza traje ca W*10uS
;-------------------------------------------------
PAVZA1W
	movwf P1W
ZP1W
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	decfsz P1W,f
	goto ZP1W 
	return
	
	
;////////////////////////////////////////////////////////////////////////
;////////////////////////////////////////////////////////////////////////	
	
TEST_DS
	
	call RESET_DS		;ca 980uS
	movlw 0xCC
	call VPISI_DS		;480us
	movlw 0x44
	call VPISI_DS		;480us
	call RESET_DS		;980 us
	movlw 0xCC
	call VPISI_DS		;480us
	movlw 0xBE
	call VPISI_DS		;480us
	call BERI_DS		;480us
	movwf NIZEK_DS
	call BERI_DS		;480us
	movwf  VISOK_DS
	call PRETVORI
	return	

;-------------------------------------------------
;procedura pripravi izmerjene vrednosti temperature
;za prikaz na displej
;-------------------------------------------------
PRETVORI
	bcf PREDZNAK		;pozitiven prikaz
	clrc
	rrf NIZEK_DS,f
	movlw .5		;5
	btfss STATUS,C		;je na decimalki 0 ali 5
	clrw	 		;0
	movwf  CIFRA
	movf VISOK_DS,w		;
	btfss STATUS,Z		;je izmerjeno negativno?
	call NEGATIVNO		;da
	clrf CIFRA+1		;ne
	clrf CIFRA+2
	clrf CIFRA+3
X2
	movlw .100
	subwf NIZEK_DS,w
	btfss STATUS,C
	goto X1
	movwf NIZEK_DS
	incf CIFRA+3,f
	goto X2
X1
	movlw .10
	subwf NIZEK_DS,W
	btfss STATUS,C
	goto X3
	movwf NIZEK_DS
	incf CIFRA+2,f
	goto X1
X3
	movf NIZEK_DS,w
	movwf CIFRA+1
	bsf TERMO_ON		;povem da gre za meritev temperature 
	movf CIFRA+3,w
	movlw .10
	btfsc STATUS,Z
	movwf CIFRA+3		;na mestu tisocice je prikaz 0, ki je ne kazem
	movf CIFRA+3,w
	sublw .10
	btfss STATUS,Z		;na tisocici ni prikaza?
	return			;ne
	movf CIFRA+2,f
	btfss STATUS,Z		;na stotici je "0" ?
	goto PREVERI_PREDZNAK	;ne
	movlw .10		;da
	movwf CIFRA+2		
	btfss PREDZNAK		;je prikaz negativen
	return			;ne
	movlw .11		;da 
	movwf CIFRA+2		;na stotico pripravim prikaz "-"
	return
PREVERI_PREDZNAK
	btfss PREDZNAK		;je negativen prikaz
	return			;ne
	movlw .11		;da 
	movwf CIFRA+3		;na tisocico prpravim prikaz "-"
	return		
		
NEGATIVNO
	bsf NIZEK_DS,7		;predpriprava za pretvorbo
	comf NIZEK_DS,F
	incf NIZEK_DS,f
	bsf PREDZNAK		;negativno
	return
	
	
;-------------------------------------------------	
;Procedura izvede branje ure
;
;-------------------------------------------------
CITAJ_CAS
	call START_BIT		;start bit I2C rutine
	movlw b'10100000'	;naslov ter posiljanje	
	call I2C_TX		;posljem
	movlw .2		;zacetna lokacija branja
	call I2C_TX		;posljem na vodilo
	call START_BIT		;start bit
	movlw b'10100001'	;naslov ter branje
	call I2C_TX		;posljem
	bcf ACK			
	call I2C_RX		;branje
	movf I2C_DATA,w		;sekund
	movwf SEKUNDE
	call I2C_RX		;branje 
	movf I2C_DATA,w		;minut
	movwf MINUTE
	bsf ACK			;
	call I2C_RX		;branje 
	movf I2C_DATA,w		;ur
	movwf URE 
	call STOP_BIT		;stop bit
	return

;-----------------------------------------------
;procedura vpie v PCF
;v W prejme lokacijo regisrov v katerih
;so vrednosti za nastavitev
;-----------------------------------------------
SHRANI_CAS
	movwf FSR		;nastavim FSR katerega rabim kasneje
	call START_BIT
	movlw b'10100000'	;druzina 
	call I2C_TX
	movlw .3		;lokacija
	call I2C_TX
	movf INDF,w
	call I2C_TX		;posljem na lokacijo vrednost med 0 59 min
	incf FSR,f
	movf INDF,w
	call I2C_TX		;posljem na lokacijo vrednost med 0-23
	call STOP_BIT
	return
				
;-----------------------------------------------
;glavna procedura
;-----------------------------------------------
GLAVNI
	clrw
	call CLRRAM	;brisnanje snr
	clrf PORTB
	clrf PORTA
	movlw b'111'
	movwf CMCON	;vsi pini so digitalni
	bsf STATUS,RP0
	clrf TRISB
	bcf KAT1
	bcf KAT2
	bcf KAT3
	bcf KAT4
;	bcf ALARM
	movlw b'01000011'
	movwf OPTION_REG	;predddelilnik 1/16 za TMR0 
	bcf STATUS,RP0
;	movlw b'00110000'
;	movwf CAS
;	movlw b'00010010'
;	movwf CAS+1
;	movlw URA2
;	call SHRANI_CAS
	movlw b'10100000'
	movwf INTCON		;vklop TMR0 prekinitve
	movlw 0xff
	movwf TIPKE
ZANKA
	btfsc TIPKA_S
	goto ZANKA
	btfss TIPKA_S
	goto $-1
	btfss TERMO_ON
	goto T_ON
	bcf TERMO_ON
	goto ZANKA
T_ON
	bsf TERMO_ON	
	goto ZANKA
	
		
	end	;eof
	
